Index: chapter01/changelog.xml
===================================================================
--- chapter01/changelog.xml	(revision 6d19228191743967e3f30ebaf833b5d0857d018b)
+++ chapter01/changelog.xml	(revision ad89f7b0d63fac3c1bca0e5d11880d97c511f84e)
@@ -41,4 +41,46 @@
     -->
     <listitem>
+      <para>2022-01-01</para>
+      <itemizedlist>
+        <listitem>
+          <para>[bdubbs] - Update to e2fsprogs-1.46.5. Fixes
+          <ulink url="&lfs-ticket-root;4974">#4974</ulink>.</para>
+        </listitem>
+        <listitem>
+          <para>[bdubbs] - Update to zstd-1.5.1. Fixes
+          <ulink url="&lfs-ticket-root;4972">#4972</ulink>.</para>
+        </listitem>
+        <listitem>
+          <para>[bdubbs] - Update to expat-2.4.2. Fixes
+          <ulink url="&lfs-ticket-root;4970">#4970</ulink>.</para>
+        </listitem>
+        <listitem>
+          <para>[bdubbs] - Update to shadow-4.10. Fixes
+          <ulink url="&lfs-ticket-root;4969">#4969</ulink>.</para>
+        </listitem>
+        <listitem revision="sysv">
+          <para>[bdubbs] - Update to sysvinit-3.01. Fixes
+          <ulink url="&lfs-ticket-root;4968">#4968</ulink>.</para>
+        </listitem>
+        <listitem>
+          <para>[bdubbs] - Update to linux-5.15.12. Fixes
+          <ulink url="&lfs-ticket-root;4967">#4967</ulink>.</para>
+        </listitem>
+        <listitem>
+          <para>[bdubbs] - Update to iana-etc-20211224. Fixes
+          <ulink url="&lfs-ticket-root;4962">#4962</ulink>.</para>
+        </listitem>
+        <listitem>
+          <para>[bdubbs] - Update to openssl-3.0.1. Fixes
+          <ulink url="&lfs-ticket-root;4922">#4922</ulink>.</para>
+        </listitem>
+        <listitem>
+          <para>[bdubbs] - Update to eudev-3.2.11. Fixes
+          <ulink url="&lfs-ticket-root;4914">#4914</ulink>.</para>
+        </listitem>
+      </itemizedlist>
+    </listitem>
+
+    <listitem>
       <para>2021-12-30</para>
       <itemizedlist>
@@ -245,5 +287,5 @@
           <ulink url="&lfs-ticket-root;4929">#4929</ulink>.</para>
         </listitem>
-        <listitem>
+        <listitem revision="sysv">
           <para>[bdubbs] - Update to sysvinit-3.0.0. Fixes
           <ulink url="&lfs-ticket-root;4927">#4927</ulink>.</para>
Index: chapter01/whatsnew.xml
===================================================================
--- chapter01/whatsnew.xml	(revision 6d19228191743967e3f30ebaf833b5d0857d018b)
+++ chapter01/whatsnew.xml	(revision ad89f7b0d63fac3c1bca0e5d11880d97c511f84e)
@@ -73,13 +73,13 @@
       <para>Diffutils-&diffutils-version;</para>
     </listitem>-->
-   <!--<listitem>
+    <listitem>
        <para>E2fsprogs-&e2fsprogs-version;</para>
-    </listitem>-->
-    <!--<listitem revision="sysv">
+    </listitem>
+    <listitem revision="sysv">
        <para>Eudev-&eudev-version;</para>
-    </listitem>-->
-   <!--<listitem>
+    </listitem>
+    <listitem>
        <para>Expat-&expat-version;</para>
-    </listitem>-->
+    </listitem>
     <!--<listitem>
        <para>Expect-&expect-version;</para>
@@ -229,7 +229,7 @@
       <para>Sed-&sed-version;</para>
     </listitem>-->
-    <!--<listitem>
+    <listitem>
       <para>Shadow-&shadow-version;</para>
-    </listitem>-->
+    </listitem>
     <!--<listitem revision="sysv">
       <para>Sysklogd-&sysklogd-version;</para>
@@ -268,7 +268,7 @@
       <para>Zlib-&zlib-version;</para>
     </listitem>-->
-    <!--<listitem>
+    <listitem>
       <para>Zstd-&zstd-version;</para>
-    </listitem>-->
+    </listitem>
   </itemizedlist>
 
@@ -288,11 +288,11 @@
       <para>file-5.40-upstream_fixes-1.patch</para>
     </listitem>
+    <listitem>
+      <para>shadow-4.10-useradd_segfault-1.patch</para>
+    </listitem>
+    <listitem revision="sysv">
+      <para>sysvinit-3.01-consolidated-1.patch</para>
+    </listitem>
     <!--
-    <listitem>
-      <para>binutils-2.37-upstream_fix-1.patch</para>
-    </listitem>
-    <listitem>
-      <para>gcc-11.1.0-upstream_fixes-1.patch</para>
-    </listitem>
     <listitem revision="systemd">
       <para>MarkupSafe-&markupsafe-version;</para>
Index: chapter03/patches.xml
===================================================================
--- chapter03/patches.xml	(revision 6d19228191743967e3f30ebaf833b5d0857d018b)
+++ chapter03/patches.xml	(revision ad89f7b0d63fac3c1bca0e5d11880d97c511f84e)
@@ -112,4 +112,12 @@
     </varlistentry>
 
+    <varlistentry>
+      <term>Shadow Segfault Fix Patch - <token>&shadow-segfault-patch-size;</token>:</term>
+      <listitem>
+        <para>Download: <ulink url="&patches-root;&shadow-segfault-patch;"/></para>
+        <para>MD5 sum: <literal>&shadow-segfault-patch-md5;</literal></para>
+      </listitem>
+    </varlistentry>
+
     <varlistentry revision="sysv">
       <term>Sysvinit Consolidated Patch - <token>&sysvinit-consolidated-patch-size;</token>:</term>
Index: chapter08/shadow.xml
===================================================================
--- chapter08/shadow.xml	(revision 6d19228191743967e3f30ebaf833b5d0857d018b)
+++ chapter08/shadow.xml	(revision ad89f7b0d63fac3c1bca0e5d11880d97c511f84e)
@@ -41,4 +41,12 @@
   <sect2 role="installation">
     <title>Installation of Shadow</title>
+
+    <para>First, apply a fix to prevent a segmentation fault when running
+    <command>useradd</command>:</para>
+
+<!-- Hardcoding the patch version because it has been merged upstream and
+     the patch will be unnecessary when the next version is released. -->
+
+<screen><userinput remap="pre">patch -Np1 -i ../shadow-4.10-useradd_segfault-1.patch</userinput></screen>
 
     <note>
Index: git-version.sh
===================================================================
--- git-version.sh	(revision 6d19228191743967e3f30ebaf833b5d0857d018b)
+++ git-version.sh	(revision ad89f7b0d63fac3c1bca0e5d11880d97c511f84e)
@@ -25,5 +25,5 @@
 	echo "]]>"                                             >> version.ent
 	echo "<!ENTITY releasedate       \"unknown\">"         >> version.ent
-	echo "<!ENTITY copyrightdate     \"1999-2021\">"       >> version.ent
+	echo "<!ENTITY copyrightdate     \"1999-2022\">"       >> version.ent
 	exit 0
 fi
Index: lfs-latest-git.php
===================================================================
--- lfs-latest-git.php	(revision 6d19228191743967e3f30ebaf833b5d0857d018b)
+++ lfs-latest-git.php	(revision ad89f7b0d63fac3c1bca0e5d11880d97c511f84e)
@@ -115,4 +115,5 @@
 if ( $package == "elfutils"   ) $dirpath = "https://sourceware.org/ftp/elfutils";
 if ( $package == "expect"     ) $dirpath = "https://sourceforge.net/projects/expect/files";
+if ( $package == "eudev"      ) $dirpath = "https://github.com/eudev-project/eudev/releases";
 if ( $package == "file"       ) $dirpath = "https://github.com/file/file/tags";
 if ( $package == "flex"       ) $dirpath = "https://github.com/westes/flex/releases";
@@ -246,4 +247,7 @@
      return find_max( $lines, "/v\d/", "/^.*v(\d[\d\.]+\d).*$/" );
 
+  if ( $package == "eudev" )
+     return find_max( $lines, "/Release/", "/^.*Release (\d[\d\.]+\d).*$/" );
+
   if ( $package == "expect" )
      return find_max( $lines, "/expect/", "/^.*expect(\d[\d\.]+\d).tar.*$/" );
Index: packages.ent
===================================================================
--- packages.ent	(revision 6d19228191743967e3f30ebaf833b5d0857d018b)
+++ packages.ent	(revision ad89f7b0d63fac3c1bca0e5d11880d97c511f84e)
@@ -141,8 +141,8 @@
 <!ENTITY diffutils-fin-sbu "0.7 SBU">
 
-<!ENTITY e2fsprogs-version "1.46.4">
-<!ENTITY e2fsprogs-size "9,298 KB">
+<!ENTITY e2fsprogs-version "1.46.5">
+<!ENTITY e2fsprogs-size "9,307 KB">
 <!ENTITY e2fsprogs-url "https://downloads.sourceforge.net/project/e2fsprogs/e2fsprogs/v&e2fsprogs-version;/e2fsprogs-&e2fsprogs-version;.tar.gz">
-<!ENTITY e2fsprogs-md5 "128f5b0f0746b28d1e3ca7e263c57094">
+<!ENTITY e2fsprogs-md5 "3da91854c960ad8a819b48b2a404eb43">
 <!ENTITY e2fsprogs-home "http://e2fsprogs.sourceforge.net/">
 <!ENTITY e2fsprogs-fin-du "93 MB">
@@ -157,15 +157,15 @@
 <!ENTITY elfutils-fin-sbu "0.9 SBU">
 
-<!ENTITY eudev-version "3.2.10">
-<!ENTITY eudev-size "1,916 KB">
-<!ENTITY eudev-url "https://dev.gentoo.org/~blueness/eudev/eudev-&eudev-version;.tar.gz">
-<!ENTITY eudev-md5 "60b135a189523f333cea5f71a3345c8d">
+<!ENTITY eudev-version "3.2.11">
+<!ENTITY eudev-size "2,075 KB">
+<!ENTITY eudev-url "https://github.com/eudev-project/eudev/releases/download/v&eudev-version;/eudev-&eudev-version;.tar.gz">
+<!ENTITY eudev-md5 "417ba948335736d4d81874fba47a30f7">
 <!ENTITY eudev-fin-du "80 MB">
 <!ENTITY eudev-fin-sbu "0.2 SBU">
 
-<!ENTITY expat-version "2.4.1">
-<!ENTITY expat-size "435 KB">
+<!ENTITY expat-version "2.4.2">
+<!ENTITY expat-size "440 KB">
 <!ENTITY expat-url "&sourceforge;expat/expat-&expat-version;.tar.xz">
-<!ENTITY expat-md5 "a4fb91a9441bcaec576d4c4a56fa3aa6">
+<!ENTITY expat-md5 "b49e50792ddb35165bab41413238f66e">
 <!ENTITY expat-home "https://libexpat.github.io/">
 <!ENTITY expat-fin-du "13 MB">
@@ -322,8 +322,8 @@
 <!ENTITY gzip-fin-sbu "0.1 SBU">
 
-<!ENTITY iana-etc-version "20211124">
+<!ENTITY iana-etc-version "20211224">
 <!ENTITY iana-etc-size "581 KB">
 <!ENTITY iana-etc-url "https://github.com/Mic92/iana-etc/releases/download/&iana-etc-version;/iana-etc-&iana-etc-version;.tar.gz">
-<!ENTITY iana-etc-md5 "87369b0d97004ea0a6eb91293f221dee">
+<!ENTITY iana-etc-md5 "f5082bd2d566f753f7e3aa8882339472">
 <!ENTITY iana-etc-home "https://www.iana.org/protocols">
 <!ENTITY iana-etc-fin-du "4.7 MB">
@@ -429,10 +429,10 @@
 <!ENTITY linux-major-version "5">
 <!ENTITY linux-minor-version "15">
-<!ENTITY linux-patch-version "7">
+<!ENTITY linux-patch-version "12">
 <!--<!ENTITY linux-version "&linux-major-version;.&linux-minor-version;">-->
 <!ENTITY linux-version "&linux-major-version;.&linux-minor-version;.&linux-patch-version;">
-<!ENTITY linux-size "119,088 KB">
+<!ENTITY linux-size "119,091 KB">
 <!ENTITY linux-url "&kernel;linux/kernel/v&linux-major-version;.x/linux-&linux-version;.tar.xz">
-<!ENTITY linux-md5 "b79700122766ccf561f032eb3c8da27e">
+<!ENTITY linux-md5 "7c3faf14ec344d6d0219b6a8b2475726">
 <!ENTITY linux-home "https://www.kernel.org/">
 <!-- measured for 5.13.4 / gcc-11.1.0 on x86_64 : minimum is
@@ -534,8 +534,8 @@
 <!ENTITY ninja-fin-sbu "0.2 SBU">
 
-<!ENTITY openssl-version "1.1.1m">
-<!ENTITY openssl-size "9,617 KB">
+<!ENTITY openssl-version "3.0.1">
+<!ENTITY openssl-size "14,660 KB">
 <!ENTITY openssl-url "https://www.openssl.org/source/openssl-&openssl-version;.tar.gz">
-<!ENTITY openssl-md5 "8ec70f665c145c3103f6e330f538a9db">
+<!ENTITY openssl-md5 "7d07e849d77d276891edd579a8832bb3">
 <!ENTITY openssl-home "https://www.openssl.org/">
 <!ENTITY openssl-fin-du "154 MB">
@@ -625,8 +625,8 @@
 <!ENTITY sed-fin-sbu "0.5 SBU">
 
-<!ENTITY shadow-version "4.9">
-<!ENTITY shadow-size "1,592 KB">
+<!ENTITY shadow-version "4.10">
+<!ENTITY shadow-size "1,624 KB">
 <!ENTITY shadow-url "&github;/shadow-maint/shadow/releases/download/v&shadow-version;/shadow-&shadow-version;.tar.xz">
-<!ENTITY shadow-md5 "126924090caf72f3de7e9261fd4e10ac">
+<!ENTITY shadow-md5 "3a7936a9d0834243816fe0977c3b956e">
 <!ENTITY shadow-home "https://shadow-maint.github.io/shadow/">
 <!ENTITY shadow-fin-du "45 MB">
@@ -658,8 +658,8 @@
 <!ENTITY systemd-fin-sbu  "2.3 SBU">
 
-<!ENTITY sysvinit-version "3.00">
-<!ENTITY sysvinit-size "125 KB">
+<!ENTITY sysvinit-version "3.01">
+<!ENTITY sysvinit-size "124 KB">
 <!ENTITY sysvinit-url "&savannah;/releases/sysvinit/sysvinit-&sysvinit-version;.tar.xz">
-<!ENTITY sysvinit-md5 "6d54ca5b648decb106103c01d415417f">
+<!ENTITY sysvinit-md5 "dc14f92af715bcfa33cc25341730452e">
 <!ENTITY sysvinit-home "&savannah-nongnu;/projects/sysvinit">
 <!ENTITY sysvinit-fin-du "1.4 MB">
@@ -758,8 +758,8 @@
 <!ENTITY zlib-fin-sbu "less than 0.1 SBU">
 
-<!ENTITY zstd-version "1.5.0">
-<!ENTITY zstd-size "1,808 KB">
+<!ENTITY zstd-version "1.5.1">
+<!ENTITY zstd-size "1,890 KB">
 <!ENTITY zstd-url "https://github.com/facebook/zstd/releases/download/v&zstd-version;/zstd-&zstd-version;.tar.gz">
-<!ENTITY zstd-md5 "a6eb7fb1f2c21fa80030a47993853e92">
+<!ENTITY zstd-md5 "b97d53547220355907dedec7de9a4f29">
 <!ENTITY zstd-home "https://facebook.github.io/zstd/">
 <!ENTITY zstd-fin-du "60 MB">
Index: patches.ent
===================================================================
--- patches.ent	(revision 6d19228191743967e3f30ebaf833b5d0857d018b)
+++ patches.ent	(revision ad89f7b0d63fac3c1bca0e5d11880d97c511f84e)
@@ -75,4 +75,8 @@
 <!ENTITY perl-fix-patch-size "1.6 KB">
 
+<!ENTITY shadow-segfault-patch "shadow-&shadow-version;-useradd_segfault-1.patch">
+<!ENTITY shadow-segfault-patch-md5 "66b299c0c9ac66fdb7c91b40df5984c0">
+<!ENTITY shadow-segfault-patch-size "1.7 KB">
+
 <!ENTITY sysvinit-consolidated-patch "sysvinit-&sysvinit-version;-consolidated-1.patch">
 <!ENTITY sysvinit-consolidated-patch-md5 "4900322141d493e74020c9cf437b2cdc">
